(function(){var P$=Clazz.newPackage("jalview.analysis"),I$=[[0,'jalview.datamodel.BinaryNode']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "TreeEngine");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['D',['ri','rj','maxDistValue','maxheight'],'I',['noseqs','noClus','mini','minj','ycount'],'O',['clusters','java.util.Vector','done','java.util.BitSet','distances','jalview.math.MatrixI','node','java.util.Vector','maxdist','jalview.datamodel.BinaryNode','+top']]]

Clazz.newMeth(C$, 'findr$I$I',  function (i, j) {
var tmp=1;
for (var k=0; k < this.noseqs; k++) {
if ((k != i) && (k != j) && (!this.done.get$I(k))  ) {
tmp=tmp + this.distances.getValue$I$I(i, k);
}}
if (this.noClus > 2) {
tmp=tmp / (this.noClus - 2);
}return tmp;
});

Clazz.newMeth(C$, 'joinClusters$I$I',  function (i, j) {
var dist=this.distances.getValue$I$I(i, j);
this.ri=this.findr$I$I(i, j);
this.rj=this.findr$I$I(j, i);
this.findClusterDistance$I$I(i, j);
var sn=Clazz.new_($I$(1,1));
sn.setLeft$jalview_datamodel_BinaryNode((this.node.elementAt$I(i)));
sn.setRight$jalview_datamodel_BinaryNode((this.node.elementAt$I(j)));
var tmpi=(this.node.elementAt$I(i));
var tmpj=(this.node.elementAt$I(j));
this.findNewDistances$jalview_datamodel_BinaryNode$jalview_datamodel_BinaryNode$D(tmpi, tmpj, dist);
tmpi.setParent$jalview_datamodel_BinaryNode(sn);
tmpj.setParent$jalview_datamodel_BinaryNode(sn);
this.node.setElementAt$O$I(sn, i);
this.clusters.get$I(i).or$java_util_BitSet(this.clusters.get$I(j));
this.clusters.get$I(j).clear$();
this.done.set$I(j);
});

Clazz.newMeth(C$, 'findMaxDist$jalview_datamodel_BinaryNode',  function (nd) {
if (nd == null ) {
return;
}if ((nd.left$() == null ) && (nd.right$() == null ) ) {
var dist=nd.dist;
if (dist > this.maxDistValue ) {
this.maxdist=nd;
this.maxDistValue=dist;
}} else {
this.findMaxDist$jalview_datamodel_BinaryNode(nd.left$());
this.findMaxDist$jalview_datamodel_BinaryNode(nd.right$());
}});

Clazz.newMeth(C$, 'cluster$',  function () {
while (this.noClus > 2){
this.findMinDistance$();
this.joinClusters$I$I(this.mini, this.minj);
--this.noClus;
}
var rightChild=this.done.nextClearBit$I(0);
var leftChild=this.done.nextClearBit$I(rightChild + 1);
this.joinClusters$I$I(leftChild, rightChild);
this.top=(this.node.elementAt$I(leftChild));
this.reCount$jalview_datamodel_BinaryNode(this.top);
this.findHeight$jalview_datamodel_BinaryNode(this.top);
this.findMaxDist$jalview_datamodel_BinaryNode(this.top);
});

Clazz.newMeth(C$, '_reCount$jalview_datamodel_BinaryNode',  function (nd) {
if (nd == null ) {
return;
}if ((nd.left$() != null ) && (nd.right$() != null ) ) {
this._reCount$jalview_datamodel_BinaryNode(nd.left$());
this._reCount$jalview_datamodel_BinaryNode(nd.right$());
var l=nd.left$();
var r=nd.right$();
nd.count=l.count + r.count;
nd.ycount=(l.ycount + r.ycount) / 2;
} else {
nd.count=1;
nd.ycount=this.ycount++;
}});

Clazz.newMeth(C$, 'findHeight$jalview_datamodel_BinaryNode',  function (nd) {
if (nd == null ) {
return this.maxheight;
}if ((nd.left$() == null ) && (nd.right$() == null ) ) {
nd.height=(nd.parent$()).height + nd.dist;
if (nd.height > this.maxheight ) {
return nd.height;
} else {
return this.maxheight;
}} else {
if (nd.parent$() != null ) {
nd.height=(nd.parent$()).height + nd.dist;
} else {
this.maxheight=0;
nd.height=0.0;
}this.maxheight=this.findHeight$jalview_datamodel_BinaryNode((nd.left$()));
this.maxheight=this.findHeight$jalview_datamodel_BinaryNode((nd.right$()));
}return this.maxheight;
});

Clazz.newMeth(C$, 'reCount$jalview_datamodel_BinaryNode',  function (nd) {
this.ycount=0;
this._reCount$jalview_datamodel_BinaryNode(nd);
});

Clazz.newMeth(C$, 'getTopNode$',  function () {
return this.top;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:10:57 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
