(function(){var P$=Clazz.newPackage("jalview.analysis.scoremodels"),p$1={},I$=[[0,'jalview.bin.Console','jalview.analysis.scoremodels.ScoreModels','jalview.util.Constants','java.util.HashMap','java.util.HashSet','jalview.analysis.AlignmentUtils','jalview.analysis.scoremodels.SimilarityScoreModel','jalview.math.Matrix']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "SecondaryStructureDistanceModel", null, 'jalview.analysis.scoremodels.DistanceScoreModel');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['S',['description'],'O',['ssRateMatrix','jalview.analysis.scoremodels.ScoreMatrix','fr','jalview.api.FeatureRenderer']]]

Clazz.newMeth(C$, 'c$',  function () {
Clazz.super_(C$, this);
}, 1);

Clazz.newMeth(C$, 'getInstance$jalview_api_AlignmentViewPanel',  function (view) {
var instance;
try {
instance=this.getClass$().getDeclaredConstructor$ClassA(Clazz.array(Class, -1, [])).newInstance$OA(Clazz.array(java.lang.Object, -1, []));
instance.configureFromAlignmentView$jalview_api_AlignmentViewPanel(view);
return instance;
} catch (e$$) {
if (Clazz.exceptionOf(e$$,"InstantiationException") || Clazz.exceptionOf(e$$,"IllegalAccessException")){
var e = e$$;
{
$I$(1,"errPrintln$O",["Error in " + this.getClass$().getName$() + ".getInstance(): " + e.getMessage$() ]);
return null;
}
} else if (Clazz.exceptionOf(e$$,"ReflectiveOperationException")){
var roe = e$$;
{
return null;
}
} else {
throw e$$;
}
}
});

Clazz.newMeth(C$, 'configureFromAlignmentView$jalview_api_AlignmentViewPanel',  function (view) {
this.fr=view.cloneFeatureRenderer$();
return true;
});

Clazz.newMeth(C$, 'findDistances$jalview_datamodel_AlignmentView$jalview_api_analysis_SimilarityParamsI',  function (seqData, params) {
var seqs=seqData.getSequences$();
var noseqs=seqs.length;
var cpwidth=0;
var similarities=Clazz.array(Double.TYPE, [noseqs, noseqs]);
var ssSource=params.getSecondaryStructureSource$();
this.ssRateMatrix=$I$(2).getInstance$().getSecondaryStructureMatrix$();
var selectedSSSource="Secondary Structure";
if (ssSource.equals$O($I$(3).SECONDARY_STRUCTURE_LABELS.get$O("jnetpred"))) {
selectedSSSource="jnetpred";
}var viscont=seqData.getVisibleContigs$();
var ssAlignmentAnnotationForSequences=Clazz.new_($I$(4,1));
var alignAnnotList=this.fr.getViewport$().getAlignment$().getAlignmentAnnotation$();
if (alignAnnotList.length > 0) {
for (var aa, $aa = 0, $$aa = alignAnnotList; $aa<$$aa.length&&((aa=($$aa[$aa])),1);$aa++) {
if (aa.sequenceRef == null ) {
continue;
}if (selectedSSSource.equals$O(aa.label)) {
ssAlignmentAnnotationForSequences.computeIfAbsent$O$java_util_function_Function(aa.sequenceRef.getName$(), (P$.SecondaryStructureDistanceModel$lambda1$||(P$.SecondaryStructureDistanceModel$lambda1$=(((P$.SecondaryStructureDistanceModel$lambda1||
(function(){/*m*/var C$=Clazz.newClass(P$, "SecondaryStructureDistanceModel$lambda1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, null, 'java.util.function.Function', 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);
/*lambda_E*/
Clazz.newMeth(C$, ['apply$S','apply$O'],  function (k) { return (Clazz.new_($I$(5,1)));});
})()
), Clazz.new_(P$.SecondaryStructureDistanceModel$lambda1.$init$,[this, null])))))).add$O(aa.description);
}}
}var seqsWithUndefinedSS=p$1.findSeqsWithUndefinedSS$jalview_datamodel_SeqCigarA$java_util_Map.apply(this, [seqs, ssAlignmentAnnotationForSequences]);
for (var vc=0; vc < viscont.length; vc+=2) {
for (var cpos=viscont[vc]; cpos <= viscont[vc + 1]; cpos++) {
++cpwidth;
var seqsWithoutGapAtCol=p$1.findSeqsWithoutGapAtColumn$jalview_datamodel_SeqCigarA$I.apply(this, [seqs, cpos]);
for (var i=0; i < (noseqs - 1); i++) {
for (var j=i + 1; j < noseqs; j++) {
var sc1=seqs[i];
var sc2=seqs[j];
var undefinedSS1=seqsWithUndefinedSS.contains$O(sc1);
var undefinedSS2=seqsWithUndefinedSS.contains$O(sc2);
if (undefinedSS1 && undefinedSS2 ) {
similarities[i][j]+=this.ssRateMatrix.getMaximumScore$();
continue;
} else if (undefinedSS1 || undefinedSS2 ) {
similarities[i][j]+=this.ssRateMatrix.getMinimumScore$();
continue;
}var gap1=!seqsWithoutGapAtCol.contains$O(sc1);
var gap2=!seqsWithoutGapAtCol.contains$O(sc2);
var ss1="*";
var ss2="*";
if (!gap1 && !undefinedSS1 ) {
var seqPosition=seqs[i].findPosition$I(cpos);
var aa=seqs[i].getRefSeq$().getAnnotation$S(selectedSSSource);
if (aa != null ) ss1=$I$(6).findSSAnnotationForGivenSeqposition$jalview_datamodel_AlignmentAnnotation$I(aa[0], seqPosition);
}if (!gap2 && !undefinedSS2 ) {
var seqPosition=seqs[j].findPosition$I(cpos);
var aa=seqs[j].getRefSeq$().getAnnotation$S(selectedSSSource);
if (aa != null ) ss2=$I$(6).findSSAnnotationForGivenSeqposition$jalview_datamodel_AlignmentAnnotation$I(aa[0], seqPosition);
}if ((!gap1 && !gap2 ) || params.includeGaps$() ) {
var similarityScore=this.ssRateMatrix.getPairwiseScore$C$C(ss1, ss2);
similarities[i][j]+=similarityScore;
}}
}
}
}
for (var i=0; i < noseqs; i++) {
for (var j=i + 1; j < noseqs; j++) {
similarities[i][j]/=cpwidth;
similarities[j][i]=similarities[i][j];
}
}
return $I$(7,"similarityToDistance$jalview_math_MatrixI",[Clazz.new_($I$(8,1).c$$DAA,[similarities])]);
});

Clazz.newMeth(C$, 'findSeqsWithoutGapAtColumn$jalview_datamodel_SeqCigarA$I',  function (seqs, columnPosition) {
var seqsWithoutGapAtCol=Clazz.new_($I$(5,1));
for (var seq, $seq = 0, $$seq = seqs; $seq<$$seq.length&&((seq=($$seq[$seq])),1);$seq++) {
var spos=seq.findPosition$I(columnPosition);
if (spos != -1) {
seqsWithoutGapAtCol.add$O(seq);
}}
return seqsWithoutGapAtCol;
}, p$1);

Clazz.newMeth(C$, 'findSeqsWithUndefinedSS$jalview_datamodel_SeqCigarA$java_util_Map',  function (seqs, ssAlignmentAnnotationForSequences) {
var seqsWithUndefinedSS=Clazz.new_($I$(5,1));
for (var seq, $seq = 0, $$seq = seqs; $seq<$$seq.length&&((seq=($$seq[$seq])),1);$seq++) {
if (p$1.isSSUndefinedOrNotAdded$jalview_datamodel_SeqCigar$java_util_Map.apply(this, [seq, ssAlignmentAnnotationForSequences])) {
seqsWithUndefinedSS.add$O(seq);
}}
return seqsWithUndefinedSS;
}, p$1);

Clazz.newMeth(C$, 'isSSUndefinedOrNotAdded$jalview_datamodel_SeqCigar$java_util_Map',  function (seq, ssAlignmentAnnotationForSequences) {
for (var label, $label = $I$(3).SECONDARY_STRUCTURE_LABELS.keySet$().iterator$(); $label.hasNext$()&&((label=($label.next$())),1);) {
var annotations=seq.getRefSeq$().getAnnotation$S(label);
if (annotations != null ) {
for (var annotation, $annotation = 0, $$annotation = annotations; $annotation<$$annotation.length&&((annotation=($$annotation[$annotation])),1);$annotation++) {
var descriptionSet=ssAlignmentAnnotationForSequences.get$O(annotation.sequenceRef.getName$());
if (descriptionSet != null ) {
if (descriptionSet.contains$O(annotation.description)) {
return false;
}}}
}}
return true;
}, p$1);

Clazz.newMeth(C$, 'getName$',  function () {
return "Secondary Structure Similarity";
});

Clazz.newMeth(C$, 'getDescription$',  function () {
return this.description;
});

Clazz.newMeth(C$, 'isDNA$',  function () {
return false;
});

Clazz.newMeth(C$, 'isProtein$',  function () {
return false;
});

Clazz.newMeth(C$, 'isSecondaryStructure$',  function () {
return true;
});

Clazz.newMeth(C$, 'toString',  function () {
return "Score between sequences based on similarity between binary vectors marking secondary structure displayed at each column";
});
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:10:57 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
