(function(){var P$=Clazz.newPackage("jalview.analytics"),p$1={},I$=[[0,'java.util.HashMap','jalview.util.ChannelProperties','jalview.bin.Cache','java.util.Random','jalview.util.UserAgent','java.lang.invoke.MethodHandles','jalview.bin.Console','StringBuilder','java.net.URL','jalview.util.HttpUtils','java.nio.charset.StandardCharsets','java.io.BufferedReader','java.io.InputStreamReader','java.util.ArrayList','java.net.URLEncoder','java.util.Collections',['java.util.AbstractMap','.SimpleEntry']]],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "Plausible");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['O',['queryStringValues','java.util.List','+jsonObject','+cookieValues']]
,['Z',['ENABLED','DEBUG'],'S',['USER_AGENT','API_BASE_URL','clientId'],'O',['instance','jalview.analytics.Plausible','defaultProps','java.util.Map']]]

Clazz.newMeth(C$, 'c$',  function () {
;C$.$init$.apply(this);
p$1.resetLists.apply(this, []);
}, 1);

Clazz.newMeth(C$, 'setEnabled$Z',  function (b) {
C$.ENABLED=b;
}, 1);

Clazz.newMeth(C$, 'sendEvent$S$S$SA',  function (eventName, urlString, propsStrings) {
this.sendEvent$S$S$Z$SA(eventName, urlString, false, propsStrings);
});

Clazz.newMeth(C$, 'sendEvent$S$S$Z$SA',  function (eventName, urlString, sendDefaultProps, propsStrings) {
p$1.resetLists.apply(this, []);
if (!C$.ENABLED) {
$I$(7).debug$S("Plausible not enabled.");
return;
}var props=Clazz.new_($I$(1,1));
if (sendDefaultProps) {
props.putAll$java_util_Map(C$.defaultProps);
}if (propsStrings != null  && propsStrings.length > 0 ) {
if (propsStrings.length % 2 != 0) {
$I$(7).warn$S("Cannot addEvent with odd number of propsStrings.  Ignoring the last one.");
}for (var i=0; i < propsStrings.length - 1; i+=2) {
var key=propsStrings[i];
var value=propsStrings[i + 1];
props.put$O$O(key, value);
}
}p$1.addJsonValue$S$S.apply(this, ["domain", "jalview.org"]);
p$1.addJsonValue$S$S.apply(this, ["name", eventName]);
var eventUrlSb=Clazz.new_($I$(8,1).c$$S,["desktop://localhost"]);
if (!"desktop://localhost".endsWith$S("/") && !urlString.startsWith$S("/") ) {
eventUrlSb.append$S("/");
}eventUrlSb.append$S(urlString);
p$1.addJsonValue$S$S.apply(this, ["url", eventUrlSb.toString()]);
p$1.addJsonObject$S$java_util_Map.apply(this, ["props", props]);
var urlSb=Clazz.new_($I$(8,1));
urlSb.append$S(C$.API_BASE_URL);
var qs=p$1.buildQueryString.apply(this, []);
if (qs != null  && qs.length$() > 0 ) {
urlSb.append$C("?");
urlSb.append$S(qs);
}try {
var url=Clazz.new_([urlSb.toString()],$I$(9,1).c$$S);
var httpURLConnection=$I$(10).openConnection$java_net_URL(url);
httpURLConnection.setRequestMethod$S("POST");
httpURLConnection.setDoOutput$Z(true);
var jsonString=p$1.buildJson.apply(this, []);
$I$(7,"debug$S",["Plausible: HTTP Request is: '" + urlSb.toString() + "'" ]);
if (C$.DEBUG) {
$I$(7).debug$S("Plausible: User-Agent is: '" + C$.USER_AGENT + "'" );
}$I$(7).debug$S("Plausible: POSTed JSON is:\n" + jsonString);
var jsonBytes=jsonString.getBytes$java_nio_charset_Charset($I$(11).UTF_8);
var jsonLength=jsonBytes.length;
httpURLConnection.setFixedLengthStreamingMode$I(jsonLength);
httpURLConnection.setRequestProperty$S$S("Content-Type", "application/json");
httpURLConnection.setRequestProperty$S$S("User-Agent", C$.USER_AGENT);
httpURLConnection.connect$();
try {
var os=httpURLConnection.getOutputStream$();
try {
os.write$BA(jsonBytes);

}finally{/*res*/os&&os.close$&&os.close$();}
}finally{}
var responseCode=httpURLConnection.getResponseCode$();
var responseMessage=httpURLConnection.getResponseMessage$();
if (responseCode < 200 || responseCode > 299 ) {
$I$(7).warn$S("Plausible connection failed: '" + responseCode + " " + responseMessage + "'" );
} else {
$I$(7).debug$S("Plausible connection succeeded: '" + responseCode + " " + responseMessage + "'" );
}if (C$.DEBUG) {
var br=Clazz.new_([Clazz.new_([(httpURLConnection.getInputStream$())],$I$(13,1).c$$java_io_InputStream)],$I$(12,1).c$$java_io_Reader);
var sb=Clazz.new_($I$(8,1));
var response;
while ((response=br.readLine$()) != null ){
sb.append$S(response);
}
var body=sb.toString();
$I$(7).debug$S("Plausible response content:\n" + body);
}} catch (e$$) {
if (Clazz.exceptionOf(e$$,"java.net.MalformedURLException")){
var e = e$$;
{
$I$(7,"debug$S$Throwable",["Somehow the Plausible BASE_URL and queryString is malformed: '" + urlSb.toString() + "'" , e]);
return;
}
} else if (Clazz.exceptionOf(e$$,"java.io.IOException")){
var e = e$$;
{
$I$(7).debug$S$Throwable("Connection to Plausible BASE_URL '" + C$.API_BASE_URL + "' failed." , e);
}
} else if (Clazz.exceptionOf(e$$,"ClassCastException")){
var e = e$$;
{
$I$(7).debug$S$Throwable("Couldn\'t cast URLConnection to HttpURLConnection in Plausible.", e);
}
} else {
throw e$$;
}
}
});

Clazz.newMeth(C$, 'addJsonObject$S$java_util_Map',  function (key, map) {
var list=Clazz.new_($I$(14,1));
for (var k, $k = map.keySet$().iterator$(); $k.hasNext$()&&((k=($k.next$())),1);) {
list.add$O(C$.stringEntry$S$S(k, map.get$O(k)));
}
p$1.addJsonObject$S$java_util_List.apply(this, [key, list]);
}, p$1);

Clazz.newMeth(C$, 'addJsonObject$S$java_util_List',  function (key, object) {
this.jsonObject.add$O(C$.objectEntry$S$O(key, object));
}, p$1);

Clazz.newMeth(C$, 'addJsonValues$S$java_util_List',  function (key, values) {
this.jsonObject.add$O(C$.objectEntry$S$O(key, values));
}, p$1);

Clazz.newMeth(C$, 'addJsonValue$S$S',  function (key, value) {
this.jsonObject.add$O(C$.objectEntry$S$O(key, value));
}, p$1);

Clazz.newMeth(C$, 'addJsonValue$S$I',  function (key, value) {
this.jsonObject.add$O(C$.objectEntry$S$O(key, Integer.valueOf$I(value)));
}, p$1);

Clazz.newMeth(C$, 'addJsonValue$S$Z',  function (key, value) {
this.jsonObject.add$O(C$.objectEntry$S$O(key, Boolean.valueOf$Z(value)));
}, p$1);

Clazz.newMeth(C$, 'addQueryStringValue$S$S',  function (key, value) {
this.queryStringValues.add$O(C$.stringEntry$S$S(key, value));
}, p$1);

Clazz.newMeth(C$, 'addCookieValue$S$S',  function (key, value) {
this.cookieValues.add$O(C$.stringEntry$S$S(key, value));
}, p$1);

Clazz.newMeth(C$, 'resetLists',  function () {
this.jsonObject=Clazz.new_($I$(14,1));
this.queryStringValues=Clazz.new_($I$(14,1));
this.cookieValues=Clazz.new_($I$(14,1));
}, p$1);

Clazz.newMeth(C$, 'getInstance$',  function () {
if (C$.instance == null ) {
C$.instance=Clazz.new_(C$);
}return C$.instance;
}, 1);

Clazz.newMeth(C$, 'reset$',  function () {
p$1.resetLists.apply(C$.getInstance$(), []);
}, 1);

Clazz.newMeth(C$, 'buildQueryString',  function () {
var sb=Clazz.new_($I$(8,1));
for (var entry, $entry = this.queryStringValues.iterator$(); $entry.hasNext$()&&((entry=($entry.next$())),1);) {
if (sb.length$() > 0) {
sb.append$C("&");
}try {
sb.append$S($I$(15,"encode$S$S",[entry.getKey$(), "UTF-8"]));
} catch (e) {
if (Clazz.exceptionOf(e,"java.io.UnsupportedEncodingException")){
sb.append$S(entry.getKey$());
} else {
throw e;
}
}
sb.append$C("=");
try {
sb.append$S($I$(15,"encode$S$S",[entry.getValue$(), "UTF-8"]));
} catch (e) {
if (Clazz.exceptionOf(e,"java.io.UnsupportedEncodingException")){
sb.append$S(entry.getValue$());
} else {
throw e;
}
}
}
return sb.toString();
}, p$1);

Clazz.newMeth(C$, 'buildCookieHeaders',  function () {
}, p$1);

Clazz.newMeth(C$, 'buildJson',  function () {
var sb=Clazz.new_($I$(8,1));
p$1.addJsonObject$StringBuilder$I$java_util_List.apply(this, [sb, 0, this.jsonObject]);
return sb.toString();
}, p$1);

Clazz.newMeth(C$, 'addJsonObject$StringBuilder$I$java_util_List',  function (sb, indent, entries) {
C$.indent$StringBuilder$I(sb, indent);
sb.append$C("{");
C$.newline$StringBuilder(sb);
var entriesI=entries.iterator$();
while (entriesI.hasNext$()){
var entry=entriesI.next$();
var key=entry.getKey$();
var value=entry.getValue$();
C$.indent$StringBuilder$I(sb, indent + 1);
sb.append$C("\"").append$S(C$.quoteEscape$S(key)).append$C("\"").append$C(":");
C$.space$StringBuilder(sb);
if (value != null  && Clazz.instanceOf(value, "java.util.List") ) {
C$.newline$StringBuilder(sb);
}p$1.addJsonValue$StringBuilder$I$O.apply(this, [sb, indent + 2, value]);
if (entriesI.hasNext$()) {
sb.append$C(",");
}C$.newline$StringBuilder(sb);
}
C$.indent$StringBuilder$I(sb, indent);
sb.append$C("}");
}, p$1);

Clazz.newMeth(C$, 'addJsonValue$StringBuilder$I$O',  function (sb, indent, value) {
if (value == null ) {
return;
}try {
if (Clazz.instanceOf(value, "java.util.Map.Entry")) {
var entry=value;
var object=Clazz.new_($I$(14,1));
object.add$O(entry);
p$1.addJsonObject$StringBuilder$I$java_util_List.apply(this, [sb, indent, object]);
} else if (Clazz.instanceOf(value, "java.util.List")) {
var valueList=value;
if (valueList.size$() > 0 && Clazz.instanceOf(valueList.get$I(0), "java.util.Map.Entry") ) {
var entryList=value;
p$1.addJsonObject$StringBuilder$I$java_util_List.apply(this, [sb, indent, entryList]);
} else {
C$.indent$StringBuilder$I(sb, indent);
sb.append$C("[");
C$.newline$StringBuilder(sb);
var valueListI=valueList.iterator$();
while (valueListI.hasNext$()){
var v=valueListI.next$();
p$1.addJsonValue$StringBuilder$I$O.apply(this, [sb, indent + 1, v]);
if (valueListI.hasNext$()) {
sb.append$C(",");
}C$.newline$StringBuilder(sb);
}
C$.indent$StringBuilder$I(sb, indent);
sb.append$S("]");
}} else if (Clazz.instanceOf(value, "java.lang.String")) {
sb.append$C("\"").append$S(C$.quoteEscape$S(value)).append$C("\"");
} else if (Clazz.instanceOf(value, "java.lang.Integer")) {
sb.append$S((value).toString());
} else if (Clazz.instanceOf(value, "java.lang.Boolean")) {
sb.append$C("\"").append$S((value).toString()).append$C("\"");
}} catch (e) {
if (Clazz.exceptionOf(e,"ClassCastException")){
$I$(7,"debug$S$Throwable",["Could not deal with type of json Object " + value.toString(), e]);
} else {
throw e;
}
}
}, p$1);

Clazz.newMeth(C$, 'quoteEscape$S',  function (s) {
if (s == null ) {
return null;
}return s.replaceAll$S$S("((?<!\\\\)(?:\\\\{2})*)\"", "$1\\\\\"");
}, 1);

Clazz.newMeth(C$, 'prettyWhitespace$StringBuilder$S$I',  function (sb, whitespace, repeat) {
if (!$I$(7).getLogger$().isDebugEnabled$()) {
return;
}if (repeat >= 0 && whitespace != null  ) {
sb.append$S(String.join$CharSequence$Iterable("", $I$(16).nCopies$I$O(repeat, whitespace)));
} else {
sb.append$S(whitespace);
}}, 1);

Clazz.newMeth(C$, 'indent$StringBuilder$I',  function (sb, indent) {
C$.prettyWhitespace$StringBuilder$S$I(sb, "  ", indent);
}, 1);

Clazz.newMeth(C$, 'newline$StringBuilder',  function (sb) {
C$.prettyWhitespace$StringBuilder$S$I(sb, "\n", -1);
}, 1);

Clazz.newMeth(C$, 'space$StringBuilder',  function (sb) {
C$.prettyWhitespace$StringBuilder$S$I(sb, " ", -1);
}, 1);

Clazz.newMeth(C$, 'objectEntry$S$O',  function (s, o) {
return Clazz.new_($I$(17,1).c$$O$O,[s, o]);
}, 1);

Clazz.newMeth(C$, 'stringEntry$S$S',  function (s, v) {
return Clazz.new_($I$(17,1).c$$O$O,[s, v]);
}, 1);

Clazz.newMeth(C$, 'getAPIBaseURL$',  function () {
try {
var url=Clazz.new_($I$(9,1).c$$S,["https://www.jalview.org/services/config/analytics/url"]);
var httpURLConnection=$I$(10).openConnection$java_net_URL(url);
httpURLConnection.setRequestMethod$S("GET");
httpURLConnection.setRequestProperty$S$S("User-Agent", C$.USER_AGENT);
httpURLConnection.setConnectTimeout$I(5000);
httpURLConnection.setReadTimeout$I(3000);
httpURLConnection.connect$();
var responseCode=httpURLConnection.getResponseCode$();
var responseMessage=httpURLConnection.getResponseMessage$();
if (responseCode < 200 || responseCode > 299 ) {
$I$(7).warn$S("Config URL connection to '" + "https://www.jalview.org/services/config/analytics/url" + "' failed: '" + responseCode + " " + responseMessage + "'" );
}var br=Clazz.new_([Clazz.new_([(httpURLConnection.getInputStream$())],$I$(13,1).c$$java_io_InputStream)],$I$(12,1).c$$java_io_Reader);
var sb=Clazz.new_($I$(8,1));
var response;
while ((response=br.readLine$()) != null ){
sb.append$S(response);
}
if (sb.length$() > 7 && sb.substring$I$I(0, 5).equals$O("https") ) {
return sb.toString();
}} catch (e$$) {
if (Clazz.exceptionOf(e$$,"java.net.MalformedURLException")){
var e = e$$;
{
$I$(7).debug$S$Throwable("Somehow the config URL is malformed: \'https://www.jalview.org/services/config/analytics/url\'", e);
}
} else if (Clazz.exceptionOf(e$$,"java.io.IOException")){
var e = e$$;
{
$I$(7).debug$S$Throwable("Connection to Plausible BASE_URL '" + C$.API_BASE_URL + "' failed." , e);
}
} else if (Clazz.exceptionOf(e$$,"ClassCastException")){
var e = e$$;
{
$I$(7).debug$S$Throwable("Couldn\'t cast URLConnection to HttpURLConnection in Plausible.", e);
}
} else {
throw e$$;
}
}
return "https://analytics.jalview.org/api/event";
}, 1);

C$.$static$=function(){C$.$static$=0;
C$.ENABLED=false;
C$.DEBUG=true;
C$.instance=null;
{
C$.defaultProps=Clazz.new_($I$(1,1));
C$.defaultProps.put$O$O("app_name", $I$(2).getProperty$S("app_name") + " Desktop");
C$.defaultProps.put$O$O("version", $I$(3).getProperty$S("VERSION"));
C$.defaultProps.put$O$O("build_date", $I$(3).getDefault$S$S("BUILD_DATE", "unknown"));
C$.defaultProps.put$O$O("java_version", System.getProperty$S("java.version"));
var val=System.getProperty$S("sys.install4jVersion");
if (val != null ) {
C$.defaultProps.put$O$O("install4j_version", val);
}val=System.getProperty$S("installer.template_version");
if (val != null ) {
C$.defaultProps.put$O$O("install4j_template_version", val);
}val=System.getProperty$S("launcher.version");
if (val != null ) {
C$.defaultProps.put$O$O("launcher.version", val);
}C$.defaultProps.put$O$O("java_arch", System.getProperty$S("os.arch") + " " + System.getProperty$S("os.name") + " " + System.getProperty$S("os.version") );
C$.defaultProps.put$O$O("os", System.getProperty$S("os.name"));
C$.defaultProps.put$O$O("os_version", System.getProperty$S("os.version"));
C$.defaultProps.put$O$O("os_arch", System.getProperty$S("os.arch"));
var installation=$I$(3).applicationProperties.getProperty$S("INSTALLATION");
if (installation != null ) {
C$.defaultProps.put$O$O("installation", installation);
}C$.API_BASE_URL=C$.getAPIBaseURL$();
C$.clientId=String.format$S$OA("%08x", Clazz.array(java.lang.Object, -1, [Integer.valueOf$I(Clazz.new_($I$(4,1)).nextInt$())]));
C$.USER_AGENT=$I$(5,"getUserAgent$S",[$I$(6).lookup$().lookupClass$().getCanonicalName$() + " " + C$.clientId ]);
};
};
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:10:57 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
