(function(){var P$=Clazz.newPackage("jalview.bin"),I$=[[0,'jalview.util.LaunchUtils','jalview.bin.Console','jalview.util.ErrorLog','java.util.ArrayList','jalview.bin.argparser.Arg','jalview.util.ChannelProperties','java.lang.management.ManagementFactory','jalview.bin.MemorySetting','java.io.File','jalview.bin.HiDPISetting']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "Launcher");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[[]
,['O',['assumeHeadlessArgs','String[]']]]

Clazz.newMeth(C$, 'main$SA',  function (args) {
if (!$I$(1).checkJavaVersion$()) {
$I$(2,"errPrintln$O",["WARNING - The Java version being used (Java " + $I$(1).getJavaVersion$() + ") may lead to problems. This installation of Jalview should be used with Java " + $I$(1).getJavaCompileVersion$() + "." ]);
}$I$(3).setPrefix$S("LAUNCHER - ");
var jvmmempc=null;
var jvmmemmax=null;
var debug=false;
var wait=true;
var quiet=false;
var headless=false;
var assumeheadless=false;
var gui=false;
var help=false;
var stdout=false;
var launcherstop=false;
var launcherprint=false;
var launcherwait=false;
var $arguments=Clazz.new_($I$(4,1));
var previousArg=null;
for (var arg, $arg = 0, $$arg = args; $arg<$$arg.length&&((arg=($$arg[$arg])),1);$arg++) {
if (arg.equals$O("--debug")) {
debug=true;
}}
for (var arg, $arg = 0, $$arg = args; $arg<$$arg.length&&((arg=($$arg[$arg])),1);$arg++) {
if (arg.equals$O("--quiet")) {
quiet=true;
} else if (arg.equals$O("--gui")) {
gui=true;
} else if (arg.equals$O("--help")) {
help=true;
} else if (arg.equals$O("--version")) {
help=true;
}if (!assumeheadless) {
for (var a, $a = 0, $$a = C$.assumeHeadlessArgs; $a<$$a.length&&((a=($$a[$a])),1);$a++) {
if (arg.equals$O("--" + a) || arg.startsWith$S("--" + a + "=" ) ) {
assumeheadless=true;
}}
}if (arg.equals$O("--output=-") || (arg.equals$O("-") && "--output".equals$O(previousArg) ) ) {
stdout=true;
}if (debug) {
if (arg.equals$O("--launcherprint")) {
launcherprint=true;
} else if (arg.equals$O("--launcherstop")) {
launcherstop=true;
} else if (arg.equals$O("--launcherwait")) {
launcherwait=true;
} else if (arg.equals$O("--launchernowait")) {
wait=false;
}}previousArg=arg;
if (arg.startsWith$S("--launcher")) {
continue;
}var jvmmempcArg=$I$(5).JVMMEMPC.getName$();
var jvmmemmaxArg=$I$(5).JVMMEMMAX.getName$();
if (arg.startsWith$S("-" + jvmmempcArg + "=" )) {
jvmmempc=arg.substring$I(jvmmempcArg.length$() + 2);
} else if (arg.startsWith$S("-" + jvmmemmaxArg + "=" )) {
jvmmemmax=arg.substring$I(jvmmemmaxArg.length$() + 2);
} else if (arg.startsWith$S("--" + jvmmempcArg + "=" )) {
jvmmempc=arg.substring$I(jvmmempcArg.length$() + 3);
} else if (arg.startsWith$S("--" + jvmmemmaxArg + "=" )) {
jvmmemmax=arg.substring$I(jvmmemmaxArg.length$() + 3);
} else {
$arguments.add$O(arg);
}}
if (help) {
headless=true;
} else if (gui) {
headless=false;
} else {
headless=assumeheadless;
}$I$(3).setQuiet$Z(quiet);
var appName=$I$(6).getProperty$S("app_name");
var javaBin=$I$(1).findJavaBin$Z(true);
var removeJvmArgs=Clazz.new_($I$(4,1));
var addJvmArgs=Clazz.new_($I$(4,1));
var memSetting=null;
var jvmArgs=$I$(7).getRuntimeMXBean$().getInputArguments$();
var useCustomisedSettings=$I$(1).getBooleanUserPreference$S("MEMORY_CUSTOMISED_SETTINGS");
if (useCustomisedSettings) {
if (jvmmempc == null ) {
jvmmempc=$I$(1,"getUserPreference$S",[$I$(8).MEMORY_JVMMEMPC]);
}if (jvmmemmax == null ) {
jvmmemmax=$I$(1,"getUserPreference$S",[$I$(8).MEMORY_JVMMEMMAX]);
}}var memSet=false;
var dockIcon=false;
var dockName=false;
var headlessProp=false;
var macosHeadlessProp=false;
for (var i=0; i < jvmArgs.size$(); i++) {
var arg=jvmArgs.get$I(i);
if (arg.startsWith$S("-Xmx")) {
if (jvmmempc == null  && jvmmemmax == null  ) {
memSetting=arg;
memSet=true;
}} else if (arg.startsWith$S("-Xdock:icon")) {
dockIcon=true;
} else if (arg.startsWith$S("-Xdock:name")) {
dockName=true;
} else if (arg.startsWith$S("-Djava.awt.headless=")) {
headlessProp=true;
} else if (arg.startsWith$S("-Dapple.awt.UIElement=")) {
macosHeadlessProp=true;
}}
if (!memSet) {
var maxMemLong=$I$(8).getMemorySetting$S$S(jvmmemmax, jvmmempc);
if (Long.$gt(maxMemLong,0 )) {
memSetting="-Xmx" + Long.toString$J(maxMemLong);
memSet=true;
addJvmArgs.add$O(memSetting);
removeJvmArgs.add$O("-Xmx");
}}if ($I$(1).isMac) {
if (!dockIcon) {
var dockIconPath=System.getProperty$S$S("launcher.appdir", ".") + $I$(9).separator + "resource" + $I$(9).separator + "jalview_logo.png" ;
addJvmArgs.add$O("-Xdock:icon=" + dockIconPath);
}if (!dockName) {
addJvmArgs.add$O("-Xdock:name=" + appName);
addJvmArgs.add$O("-Dcom.apple.mrj.application.apple.menu.about.name=" + appName);
}}if (headless && !headlessProp ) {
System.setProperty$S$S("java.awt.headless", "true");
if (help) {
addJvmArgs.add$O("-Djava.awt.headless=true");
}}if (headless && $I$(1).isMac && !macosHeadlessProp  ) {
System.setProperty$S$S("apple.awt.UIElement", "true");
addJvmArgs.add$O("-Dapple.awt.UIElement=true");
}var scalePropertyArg=$I$(10).getScalePropertyArg$();
if (scalePropertyArg != null ) {
$I$(3).errPrintln$S("Running " + "jalview.bin.Jalview" + " with scale setting " + scalePropertyArg );
addJvmArgs.add$O(scalePropertyArg);
}var exitValue=$I$(1).startNewJvm$S$java_util_List$java_util_List$java_util_List$java_util_List$java_util_List$S$java_util_List$java_util_List$java_util_List$Z$Z$Z$Z$Z(javaBin, removeJvmArgs, addJvmArgs, null, null, null, "jalview.bin.Jalview", null, null, $arguments, launcherprint, launcherwait, launcherstop, debug, quiet);
$I$(3).errPrintln$S("JVM exited with value " + exitValue);
}, 1);

C$.$static$=function(){C$.$static$=0;
C$.assumeHeadlessArgs=Clazz.array(String, -1, ["headless", "output", "image", "structureimage"]);
};

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:02 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
