(function(){var P$=Clazz.newPackage("jalview.datamodel"),I$=[[0,'java.util.Arrays','java.util.BitSet','java.util.HashMap','java.util.ArrayList','java.awt.Color','jalview.analysis.AverageDistanceEngine','jalview.bin.Console','jalview.io.NewickFile']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "GroupSet", null, null, 'jalview.datamodel.GroupSetI');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.groups=$I$(1,"asList$OA",[Clazz.array($I$(2), -1, [])]);
this.newick=null;
this.abs=false;
this.thresh=0;
this.treeType=null;
this.colorMap=Clazz.new_($I$(3,1));
},1);

C$.$fields$=[['Z',['abs'],'D',['thresh'],'S',['newick','treeType'],'O',['groups','java.util.List','colorMap','java.util.HashMap']]]

Clazz.newMeth(C$, 'c$$jalview_datamodel_GroupSet',  function (grps) {
;C$.$init$.apply(this);
this.abs=grps.abs;
this.colorMap=Clazz.new_($I$(3,1).c$$java_util_Map,[grps.colorMap]);
this.groups=Clazz.new_($I$(4,1).c$$java_util_Collection,[grps.groups]);
this.newick=grps.newick;
this.thresh=grps.thresh;
this.treeType=grps.treeType;
}, 1);

Clazz.newMeth(C$, 'c$',  function () {
;C$.$init$.apply(this);
}, 1);

Clazz.newMeth(C$, 'c$$Z$F$java_util_List$S$S',  function (abs2, thresh2, groups2, treeType2, newick2) {
;C$.$init$.apply(this);
this.abs=abs2;
this.thresh=thresh2;
this.groups=groups2;
this.treeType=treeType2;
this.newick=newick2;
}, 1);

Clazz.newMeth(C$, 'hasGroups$',  function () {
return this.groups != null ;
});

Clazz.newMeth(C$, 'getNewick$',  function () {
return this.newick;
});

Clazz.newMeth(C$, 'hasTree$',  function () {
return this.newick != null  && this.newick.length$() > 0 ;
});

Clazz.newMeth(C$, 'updateGroups$java_util_List',  function (colGroups) {
if (colGroups != null ) {
this.groups=colGroups;
}});

Clazz.newMeth(C$, 'getGroupsFor$I',  function (column) {
if (this.groups != null ) {
for (var gp, $gp = this.groups.iterator$(); $gp.hasNext$()&&((gp=($gp.next$())),1);) {
if (gp.get$I(column)) {
return gp;
}}
}var bs=Clazz.new_($I$(2,1));
bs.set$I(column);
return bs;
});

Clazz.newMeth(C$, 'getColourForGroup$java_util_BitSet',  function (bs) {
if (bs == null ) {
return $I$(5).white;
}var groupCol=this.colorMap.get$O(bs);
if (groupCol == null ) {
return $I$(5).white;
}return groupCol;
});

Clazz.newMeth(C$, 'setColorForGroup$java_util_BitSet$java_awt_Color',  function (bs, color) {
this.colorMap.put$O$O(bs, color);
});

Clazz.newMeth(C$, 'restoreGroups$java_util_List$S$S$D',  function (newgroups, treeMethod, tree, thresh2) {
this.treeType=treeMethod;
this.groups=newgroups;
this.thresh=thresh2;
this.newick=tree;
});

Clazz.newMeth(C$, 'hasCutHeight$',  function () {
return this.groups != null  && this.thresh != 0  ;
});

Clazz.newMeth(C$, 'getCutHeight$',  function () {
return this.thresh;
});

Clazz.newMeth(C$, 'getTreeMethod$',  function () {
return this.treeType;
});

Clazz.newMeth(C$, 'makeGroups$jalview_datamodel_ContactMatrixI$Z',  function (matrix, autoCut) {
return C$.makeGroups$jalview_datamodel_ContactMatrixI$Z$F$Z(matrix, autoCut, 0, autoCut);
}, 1);

Clazz.newMeth(C$, 'makeGroups$jalview_datamodel_ContactMatrixI$Z$F$Z',  function (matrix, auto, thresh, abs) {
var clusterer=Clazz.new_($I$(6,1).c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_AlignmentAnnotation$jalview_datamodel_ContactMatrixI$Z,[null, null, matrix, true]);
var height=clusterer.findHeight$jalview_datamodel_BinaryNode(clusterer.getTopNode$());
$I$(7,"debug$S",["Column tree height: " + new Double(height).toString()]);
var newick=Clazz.new_([clusterer.getTopNode$(), false, true],$I$(8,1).c$$jalview_datamodel_BinaryNode$Z$Z).print$();
var treeType="UPGMA";
$I$(7).trace$S("Newick string\n" + newick);
var nodegroups;
var cut=-1.0;
if (auto) {
var rootw=0;
var p=2;
var bn=clusterer.getTopNode$();
while (!!(p-- > 0 & bn.left$() != null )){
if (bn.left$() != null ) {
bn=bn.left$();
}if (bn.left$() != null ) {
rootw=bn.height;
}}
thresh=Math.max((rootw / height) - 0.01, 0);
cut=thresh;
nodegroups=clusterer.groupNodes$F(thresh);
} else {
if (abs ? (height > thresh ) : (0 < thresh  && thresh < 1  )) {
cut=abs ? thresh : (thresh * height);
$I$(7,"debug$S",["Threshold " + new Float(cut).toString() + " for height=" + new Double(height).toString() ]);
nodegroups=clusterer.groupNodes$F(cut);
} else {
nodegroups=Clazz.new_($I$(4,1));
nodegroups.add$O(clusterer.getTopNode$());
}}var groups=Clazz.new_($I$(4,1));
for (var root, $root = nodegroups.iterator$(); $root.hasNext$()&&((root=($root.next$())),1);) {
var gpset=Clazz.new_($I$(2,1));
for (var leaf, $leaf = clusterer.findLeaves$jalview_datamodel_BinaryNode(root).iterator$(); $leaf.hasNext$()&&((leaf=($leaf.next$())),1);) {
gpset.set$I((leaf.element$()).$c());
}
groups.add$O(gpset);
}
var grps=Clazz.new_(C$.c$$Z$F$java_util_List$S$S,[abs, (cut == -1.0 ) ? thresh : cut, groups, treeType, newick]);
return grps;
}, 1);

Clazz.newMeth(C$, 'getGroups$',  function () {
return this.groups;
});
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:04 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
