(function(){var P$=Clazz.newPackage("jalview.renderer"),I$=[[0,['jalview.renderer.ContactGeometry','.contactInterval'],'java.util.Arrays']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "ContactGeometry", function(){
Clazz.newInstance(this, arguments,0,C$);
});
C$.$classes$=[['contactInterval',1]];

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['D',['contacts_per_pixel','contacts_step'],'I',['pixels_step','contact_height','graphHeight','lastStep'],'O',['contacts','jalview.datamodel.ContactListI']]]

Clazz.newMeth(C$, 'c$$jalview_datamodel_ContactListI$I',  function (contacts, graphHeight) {
;C$.$init$.apply(this);
this.contacts=contacts;
this.graphHeight=graphHeight;
this.contact_height=contacts.getContactHeight$();
this.contacts_per_pixel=(graphHeight <= 1) ? this.contact_height : (this.contact_height) / (graphHeight);
if (this.contacts_per_pixel >= 1 ) {
this.pixels_step=1;
} else {
this.pixels_step=(Math.ceil((graphHeight) / this.contact_height)|0);
}this.contacts_step=this.pixels_step * this.contacts_per_pixel;
this.lastStep=(Math.min(graphHeight, (graphHeight) / (this.pixels_step))|0);
}, 1);

Clazz.newMeth(C$, 'intersects$jalview_renderer_ContactGeometry_contactInterval$jalview_datamodel_ColumnSelection$jalview_datamodel_HiddenColumns$Z',  function (ci, columnSelection, hiddenColumns, visibleOnly) {
var rowsel=false;
var mappedRange=this.contacts.getMappedPositionsFor$I$I(ci.cStart, ci.cEnd);
if (mappedRange == null ) {
return false;
}for (var p=0; p < mappedRange.length && !rowsel ; p+=2) {
var containsHidden=false;
if (visibleOnly && hiddenColumns != null   && hiddenColumns.hasHiddenColumns$() ) {
var viscont=hiddenColumns.getVisContigsIterator$I$I$Z(-1 + mappedRange[p], -1 + mappedRange[p + 1], false);
containsHidden=!viscont.hasNext$();
if (!containsHidden) {
for (var interval=viscont.next$(); viscont.hasNext$(); rowsel=!!(rowsel|(columnSelection.intersects$I$I(interval[p], interval[p + 1])))) ;
}} else {
rowsel=columnSelection.intersects$I$I(-1 + mappedRange[p], -1 + mappedRange[p + 1]);
}}
return rowsel;
});

Clazz.newMeth(C$, 'mapFor$I$I',  function (pStart, pEnd) {
if (pStart < 0) {
pStart=0;
}if (pEnd < pStart) {
pEnd=pStart;
}if (pEnd >= this.graphHeight) {
pEnd=this.graphHeight - 1;
}if (pStart >= this.graphHeight) {
pStart=this.graphHeight - this.pixels_step;
}var step=Math.floorDiv(pStart, this.pixels_step);
return this.findStep$I(step);
});

Clazz.newMeth(C$, 'findStep$I',  function (step) {
if (step < 0 || step > this.lastStep ) {
return null;
}return Clazz.new_([this, null, (Math.floor(this.contacts_step * step)|0), -1 + (Math.min(this.contact_height, Math.floor(this.contacts_step * (step + 1)))|0), this.pixels_step * step, Math.min(this.graphHeight, (step + 1) * this.pixels_step) - 1],$I$(1,1).c$$I$I$I$I);
});

Clazz.newMeth(C$, 'mapFor$I',  function (pCentre) {
if (pCentre >= this.graphHeight + this.pixels_step) {
return null;
}var step=Math.floorDiv(pCentre, this.pixels_step);
return this.findStep$I(step);
});

Clazz.newMeth(C$, 'allSteps$',  function () {
var array=Clazz.array($I$(1), [this.lastStep + 1]);
var csum=0;
var psum=0;
for (var i=0; i <= this.lastStep; i++) {
array[i]=this.findStep$I(i);
csum+=1 + array[i].cEnd - array[i].cStart;
psum+=1 + array[i].pEnd - array[i].pStart;
}
if (csum != this.contact_height || psum != this.graphHeight ) {
System.err.println$S("csum = " + csum + " not " + this.contact_height + "\n" + "psum = " + psum + " not " + this.graphHeight );
return null;
}return $I$(2).asList$OA(array);
});

Clazz.newMeth(C$, 'iterateOverContactIntervals$I',  function (graphHeight) {
return null;
});
;
(function(){/*c*/var C$=Clazz.newClass(P$.ContactGeometry, "contactInterval", function(){
Clazz.newInstance(this, arguments[0],true,C$);
});

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

C$.$fields$=[['I',['cStart','cEnd','pStart','pEnd']]]

Clazz.newMeth(C$, 'c$$I$I$I$I',  function (cStart, cEnd, pStart, pEnd) {
;C$.$init$.apply(this);
this.cStart=cStart;
this.cEnd=cEnd;
this.pStart=pStart;
this.pEnd=pEnd;
}, 1);

Clazz.newMeth(C$, 'equals$O',  function (obj) {
if (obj == null  || !(Clazz.instanceOf(obj, "jalview.renderer.ContactGeometry.contactInterval")) ) {
return false;
}var them=obj;
return this.cStart == them.cStart && this.cEnd == them.cEnd  && this.pEnd == them.pEnd  && this.pStart == them.pStart ;
});

Clazz.newMeth(C$, 'toString',  function () {
return "Contacts [" + this.cStart + "," + this.cEnd + "] : Pixels [" + this.pStart + "," + this.pEnd + "]" ;
});

Clazz.newMeth(C$);
})()

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:15 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
