(function(){var P$=Clazz.newPackage("jalview.ws.datamodel.alphafold"),p$1={},p$2={},I$=[[0,'jalview.util.MapList','Error','java.util.ArrayList','jalview.datamodel.ContactListImpl']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "MappableContactMatrix", null, null, 'jalview.ws.datamodel.MappableContactMatrixI');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.mappedMatrix=null;
this.refSeq=null;
this.toSeq=null;
},1);

C$.$fields$=[['I',['length'],'O',['mappedMatrix','jalview.datamodel.ContactMatrixI','refSeq','jalview.datamodel.SequenceI','toSeq','jalview.util.MapList']]]

Clazz.newMeth(C$, 'getContactList$I',  function (column) {
return this.mappedMatrix.getContactList$I(column);
});

Clazz.newMeth(C$, 'getMin$',  function () {
return this.mappedMatrix.getMin$();
});

Clazz.newMeth(C$, 'getMax$',  function () {
return this.mappedMatrix.getMax$();
});

Clazz.newMeth(C$, 'getWidth$',  function () {
return this.mappedMatrix.getWidth$();
});

Clazz.newMeth(C$, 'getHeight$',  function () {
return this.mappedMatrix.getHeight$();
});

Clazz.newMeth(C$, 'getMappedMatrix$',  function () {
return this.mappedMatrix;
});

Clazz.newMeth(C$, 'getGroupSet$',  function () {
return this.mappedMatrix.getGroupSet$();
});

Clazz.newMeth(C$, 'setGroupSet$jalview_datamodel_GroupSet',  function (makeGroups) {
this.mappedMatrix.setGroupSet$jalview_datamodel_GroupSet(makeGroups);
});

Clazz.newMeth(C$, 'hasReferenceSeq$',  function () {
return (this.refSeq != null );
});

Clazz.newMeth(C$, 'getReferenceSeq$',  function () {
return this.refSeq;
});

Clazz.newMeth(C$, 'getMapFor$jalview_datamodel_SequenceI',  function (mapSeq) {
if (this.refSeq != null ) {
while (mapSeq !== this.refSeq  && mapSeq.getDatasetSequence$() != null  ){
mapSeq=mapSeq.getDatasetSequence$();
}
if (mapSeq !== this.refSeq ) {
return null;
}} else {
if (mapSeq != null ) {
return null;
}}return this.toSeq;
});

Clazz.newMeth(C$, 'setRefSeq$jalview_datamodel_SequenceI',  function (_refSeq) {
this.refSeq=_refSeq;
while (this.refSeq.getDatasetSequence$() != null ){
this.refSeq=this.refSeq.getDatasetSequence$();
}
this.length=_refSeq.getEnd$() - _refSeq.getStart$() + 1;
{
this.toSeq=Clazz.new_([Clazz.array(Integer.TYPE, -1, [_refSeq.getStart$(), _refSeq.getEnd$()]), Clazz.array(Integer.TYPE, -1, [0, this.length - 1]), 1, 1],$I$(1,1).c$$IA$IA$I$I);
}});

Clazz.newMeth(C$, 'liftOver$jalview_datamodel_SequenceI$jalview_datamodel_Mapping',  function (newRefSeq, sp2sq) {
if (sp2sq.getMappedWidth$() != sp2sq.getWidth$()) {
throw Clazz.new_($I$(2,1).c$$S,["liftOver currently not implemented for transfer of annotation between different types of seqeunce"]);
}var mapIsTo=(sp2sq != null ) ? (sp2sq.getTo$() === this.refSeq ) : false;
var refMap=this.toSeq.locateInFrom$I$I(0, this.length - 1);
var newFromMap=Clazz.new_($I$(3,1));
var last=-1;
for (var i=0; i < refMap.length; i+=2) {
var sp2map=mapIsTo ? sp2sq.getMap$().locateInFrom$I$I(refMap[i], refMap[i + 1]) : sp2sq.getMap$().locateInTo$I$I(refMap[i], refMap[i + 1]);
if (sp2map == null ) {
continue;
}for (var spm=0; spm < sp2map.length; spm+=2) {
if (last > -1) {
if (sp2map[spm] != last + 1) {
newFromMap.add$O(Integer.valueOf$I(sp2map[spm]));
} else {
newFromMap.remove$I(newFromMap.size$() - 1);
}} else {
newFromMap.add$O(Integer.valueOf$I(sp2map[spm]));
}last=sp2map[spm + 1];
newFromMap.add$O(Integer.valueOf$I(last));
}
}
if ((newFromMap.size$() % 2) != 0) {
throw Clazz.new_($I$(2,1).c$$S,["PAEMatrix liftover failed."]);
}var fromIntMap=Clazz.array(Integer.TYPE, [newFromMap.size$()]);
var ipos=0;
for (var i, $i = newFromMap.iterator$(); $i.hasNext$()&&((i=($i.next$())),1);) {
fromIntMap[ipos++]=(i).$c();
}
var newFromMapList=Clazz.new_([fromIntMap, Clazz.array(Integer.TYPE, -1, [0, this.length - 1]), 1, 1],$I$(1,1).c$$IA$IA$I$I);
var newCM=this.newMappableContactMatrix$jalview_datamodel_SequenceI$jalview_util_MapList(newRefSeq, newFromMapList);
return newCM;
});

Clazz.newMeth(C$, 'getMappedPositionsFor$jalview_datamodel_SequenceI$I',  function (localFrame, column) {
return this.getMappedPositionsFor$jalview_datamodel_SequenceI$I$I(localFrame, column, column);
});

Clazz.newMeth(C$, 'getMappedPositionsFor$jalview_datamodel_SequenceI$I$I',  function (localFrame, from, to) {
if (localFrame == null ) {
throw Clazz.new_($I$(2,1).c$$S,["Unimplemented when no local sequence given."]);
}var lf=localFrame;
var uf=this.refSeq;
while (lf.getDatasetSequence$() != null  || uf.getDatasetSequence$() != null  ){
if (lf.getDatasetSequence$() != null ) {
lf=lf.getDatasetSequence$();
}if (uf.getDatasetSequence$() != null ) {
uf=uf.getDatasetSequence$();
}}
if (lf !== uf ) {
throw Clazz.new_(["This Matrix associated with '" + this.refSeq.getName$() + "' is not mappable for the given localFrame sequence. (" + localFrame.getName$() + ")" ],$I$(2,1).c$$S);
}if (this.toSeq == null ) {
return Clazz.array(Integer.TYPE, -1, [from, to]);
}var mappedPositions=this.toSeq.locateInFrom$I$I(from, to);
if (mappedPositions == null ) {
return null;
}return mappedPositions;
});

Clazz.newMeth(C$, 'getMappableContactList$jalview_datamodel_SequenceI$I',  function (localFrame, column) {
var _column;
var _lcolumn;
if (localFrame == null ) {
throw Clazz.new_($I$(2,1).c$$S,["Unimplemented when no local sequence given."]);
}var us=this;
_lcolumn=localFrame.findPosition$I(column);
if (this.toSeq != null ) {
var lf=localFrame;
var uf=this.refSeq;
while (lf.getDatasetSequence$() != null  || uf.getDatasetSequence$() != null  ){
if (lf.getDatasetSequence$() != null ) {
lf=lf.getDatasetSequence$();
}if (uf.getDatasetSequence$() != null ) {
uf=uf.getDatasetSequence$();
}}
if (lf !== uf ) {
throw Clazz.new_(["This Matrix associated with '" + this.refSeq.getName$() + "' is not mappable for the given localFrame sequence. (" + localFrame.getName$() + ")" ],$I$(2,1).c$$S);
}var word=this.toSeq.locateInTo$I$I(_lcolumn, _lcolumn);
if (word == null ) {
return null;
}_column=word[0];
} else {
_column=_lcolumn;
}if (_column < 0 || ((this.toSeq != null  && _column > this.toSeq.getToHighest$() ) || (this.toSeq == null  && this.getHeight$() <= _column ) ) ) {
return null;
}var matrixRange=this.toSeq == null  ? Clazz.array(Integer.TYPE, -1, [localFrame.getStart$(), localFrame.getEnd$()]) : this.toSeq.locateInTo$I$I(localFrame.getStart$(), localFrame.getEnd$());
var h=0;
for (var p=0; p < matrixRange.length; p+=2) {
h+=1 + Math.abs(matrixRange[p + 1] - matrixRange[p]);
}
var rangeHeight=h;
return Clazz.new_([((P$.MappableContactMatrix$1||
(function(){/*a*/var C$=Clazz.newClass(P$, "MappableContactMatrix$1", function(){Clazz.newInstance(this, arguments[0],1,C$);}, null, 'jalview.datamodel.ContactListProviderI', 1);

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

Clazz.newMeth(C$, 'getColumn$',  function () {
return this.$finals$.column;
});

Clazz.newMeth(C$, 'getPosition$',  function () {
return this.$finals$._column;
});

Clazz.newMeth(C$, 'getContactHeight$',  function () {
return this.$finals$.rangeHeight;
});

Clazz.newMeth(C$, 'getContactAt$I',  function (mcolumn) {
if (mcolumn < 0 || mcolumn >= this.$finals$.rangeHeight ) {
return -1;
}return this.b$['jalview.ws.datamodel.alphafold.MappableContactMatrix'].getElementAt$I$I.apply(this.b$['jalview.ws.datamodel.alphafold.MappableContactMatrix'], [this.$finals$._column, p$1.locateInRange$I.apply(this, [mcolumn])]);
});

Clazz.newMeth(C$, 'getMappedPositionsFor$I$I',  function (cStart, cEnd) {
if (!this.b$['jalview.ws.datamodel.alphafold.MappableContactMatrix'].hasReferenceSeq$.apply(this.b$['jalview.ws.datamodel.alphafold.MappableContactMatrix'], [])) {
return jalview.datamodel.ContactListProviderI.superclazz.prototype.getMappedPositionsFor$I$I.apply(this.b$['jalview.datamodel.ContactListProviderI'], [cStart, cEnd]);
}var realCstart=p$1.locateInRange$I.apply(this, [cStart]);
var realCend=p$1.locateInRange$I.apply(this, [cEnd]);
var mappedPositions=this.b$['jalview.ws.datamodel.alphafold.MappableContactMatrix'].toSeq.locateInFrom$I$I(realCstart, realCend);
if (mappedPositions != null ) {
var s=-1;
var e=-1;
for (var p=0; p < mappedPositions.length; p++) {
if (s == -1 && mappedPositions[p] >= this.$finals$.localFrame.getStart$() ) {
s=p;
}if (e == -1 || mappedPositions[p] <= this.$finals$.localFrame.getEnd$() ) {
e=p;
mappedPositions[p]=this.$finals$.localFrame.findIndex$I(mappedPositions[p]);
}}
}return mappedPositions;
});

Clazz.newMeth(C$, 'locateInRange$I',  function (mcolumn) {
var h=0;
var p=0;
while (h < mcolumn && p + 2 < this.$finals$.matrixRange.length ){
h+=1 + Math.abs(this.$finals$.matrixRange[p + 1] - this.$finals$.matrixRange[p]);
p+=2;
}
return this.$finals$.matrixRange[p] + mcolumn - h;
}, p$2);

Clazz.newMeth(C$, 'getColourForGroup$',  function () {
var gp=this.$finals$.us.getGroupsFor$I(this.$finals$._column);
var col=this.$finals$.us.getColourForGroup$java_util_BitSet(gp);
return col;
});
})()
), Clazz.new_(P$.MappableContactMatrix$1.$init$,[this, {matrixRange:matrixRange,_column:_column,column:column,rangeHeight:rangeHeight,localFrame:localFrame,us:us}]))],$I$(4,1).c$$jalview_datamodel_ContactListProviderI);
});

Clazz.newMeth(C$, 'getElementAt$I$I',  function (_column, i) {
return this.mappedMatrix.getElementAt$I$I(_column, i);
});

Clazz.newMeth(C$, 'hashCode$',  function () {
return 7 * (this.refSeq != null  ? this.refSeq.hashCode$() : 0) + 11 * (this.toSeq != null  ? this.toSeq.hashCode$() : 0) + 13 * (this.mappedMatrix != null  ? this.mappedMatrix.hashCode$() : 0) + this.length * 3;
});

Clazz.newMeth(C$, 'equals$O',  function (obj) {
if (obj == null  || !(obj.getClass$().equals$O(this.getClass$())) ) {
return false;
}var them=obj;
return this.mappedMatrix === them.mappedMatrix  && this.length == them.length  && this.refSeq === them.refSeq   && this.toSeq.equals$O(them.toSeq) ;
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:17 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
