(function(){var P$=Clazz.newPackage("jalview.gui"),I$=[[0,'StringBuilder','java.util.Vector','jalview.analysis.AlignSeq','jalview.bin.Console','jalview.datamodel.SequenceI','jalview.gui.AlignFrame','jalview.datamodel.Alignment','jalview.gui.Desktop','jalview.util.MessageManager']],I$0=I$[0],$I$=function(i,n,m){return m?$I$(i)[n].apply(null,m):((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "PairwiseAlignPanel", null, 'jalview.jbgui.GPairwiseAlignPanel');

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
this.seqs=null;
this.etime=NaN;
},1);

C$.$fields$=[['Z',['quiet','discardAlignments','endGaps','cancelled'],'D',['etime'],'I',['GAP_OPEN_COST','GAP_EXTEND_COST'],'J',['total','progress'],'S',['alignmentOutput'],'O',['scores','float[][]','+alignmentScores','av','jalview.viewmodel.AlignmentViewport','sequences','java.util.Vector','selection','jalview.datamodel.SequenceGroup','seqs','jalview.datamodel.SequenceI[]','scoreMatrix','jalview.analysis.scoremodels.ScoreMatrix']]]

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport',  function (viewport) {
C$.c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_SequenceGroup$Z$I$I$Z$jalview_analysis_scoremodels_ScoreMatrix.apply(this, [viewport, null, false, 120, 20, true, null]);
}, 1);

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_analysis_scoremodels_ScoreMatrix',  function (viewport, params) {
C$.c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_SequenceGroup$Z$I$I$Z$jalview_analysis_scoremodels_ScoreMatrix.apply(this, [viewport, null, false, 120, 20, true, params]);
}, 1);

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$Z$I$I',  function (viewport, endGaps, gapOpenCost, gapExtendCost) {
C$.c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_SequenceGroup$Z$I$I$Z$jalview_analysis_scoremodels_ScoreMatrix.apply(this, [viewport, null, endGaps, gapOpenCost, gapExtendCost, true, null]);
}, 1);

Clazz.newMeth(C$, 'c$$jalview_viewmodel_AlignmentViewport$jalview_datamodel_SequenceGroup$Z$I$I$Z$jalview_analysis_scoremodels_ScoreMatrix',  function (viewport, selection, endGaps, gapOpenCost, gapExtendCost, run, scoreMatrix) {
;C$.superclazz.c$.apply(this,[]);C$.$init$.apply(this);
this.av=viewport;
this.GAP_OPEN_COST=gapOpenCost;
this.GAP_EXTEND_COST=gapExtendCost;
this.endGaps=endGaps;
this.selection=selection;
this.total=this.av.getAlignment$().getHeight$();
this.total=Long.$div((Long.$sub(Long.$mul(this.total,this.total),this.total)),2);
this.scoreMatrix=scoreMatrix;
if (run) {
this.calculate$();
}}, 1);

Clazz.newMeth(C$, 'calculate$',  function () {
this.calculate$jalview_analysis_scoremodels_ScoreMatrix(this.scoreMatrix);
});

Clazz.newMeth(C$, 'calculate$jalview_analysis_scoremodels_ScoreMatrix',  function (sm) {
this.cancelled=false;
var sb=Clazz.new_($I$(1,1).c$$I,[1024]);
this.sequences=Clazz.new_($I$(2,1));
var seqStrings;
this.seqs=null;
if (this.selection != null ) {
this.seqs=this.selection.getSelectionAsNewSequences$jalview_datamodel_AlignmentI(this.av.getAlignment$());
seqStrings=Clazz.array(String, [this.seqs.length]);
var s=0;
for (var seq, $seq = 0, $$seq = this.seqs; $seq<$$seq.length&&((seq=($$seq[$seq])),1);$seq++) {
seqStrings[s++]=seq.getSequenceAsString$();
}
} else {
var selectionGroup=this.av.getSelectionGroup$();
var isSelection=selectionGroup != null  && selectionGroup.getSize$() > 0 ;
var view=this.av.getAlignmentView$Z(isSelection);
seqStrings=view.getSequenceStrings$C(this.av.getGapCharacter$());
if (isSelection) {
this.seqs=view.getAlignmentAndHiddenColumns$C(this.av.getGapCharacter$())[0];
} else {
this.seqs=this.av.getAlignment$().getSequencesArray$();
}}var type=(this.av.getAlignment$().isNucleotide$()) ? "dna" : "pep";
var scores=Clazz.array(Float.TYPE, [this.seqs.length, this.seqs.length]);
var alignmentScores=Clazz.array(Float.TYPE, [this.seqs.length, this.seqs.length]);
var totscore=0.0;
var count=this.seqs.length;
var fracprogress=0;
var first=true;
var time=System.currentTimeMillis$();
var fprogress=0;
this.firePropertyChange$S$I$I("total", 0, 500);
for (var i=1; i < count; i++) {
alignmentScores[i - 1][i - 1]=NaN;
for (var j=0; j < i; j++) {
if (this.cancelled) {
this.alignmentOutput="Alignment was cancelled.";
return;
}var as=Clazz.new_($I$(3,1).c$$jalview_datamodel_SequenceI$S$jalview_datamodel_SequenceI$S$S$I$I,[this.seqs[i], seqStrings[i], this.seqs[j], seqStrings[j], type, this.GAP_OPEN_COST, this.GAP_EXTEND_COST]);
if (sm != null ) {
as.setScoreMatrix$jalview_analysis_scoremodels_ScoreMatrix(sm);
}if (as.s1str.length$() == 0 || as.s2str.length$() == 0 ) {
continue;
}as.calcScoreMatrix$();
if (this.endGaps) {
as.traceAlignmentWithEndGaps$();
} else {
as.traceAlignment$();
}as.scoreAlignment$();
if (!first && !this.quiet ) {
$I$(4).outPrintln$O("---------------------\n");
this.textarea.append$S("---------------------\n");
sb.append$S("---------------------\n");
}first=false;
if (!this.discardAlignments) {
as.printAlignment$java_io_PrintStream(System.out);
}scores[i][j]=as.getMaxScore$() / as.getASeq1$().length;
alignmentScores[i][j]=as.getAlignmentScore$();
totscore=totscore + scores[i][j];
if (!this.quiet) {
this.textarea.append$S(as.getOutput$());
sb.append$S(as.getOutput$());
}if (!this.discardAlignments) {
this.sequences.add$O(as.getAlignedSeq1$());
this.sequences.add$O(as.getAlignedSeq2$());
}(fprogress=Long.$inc(fprogress,1));
}
if (i < count) {
var newfracprogress=(Math.floor((500.0 * Long.$dval(fprogress)) / (Long.$dval(this.total)))|0);
this.firePropertyChange$S$I$I("progress", fracprogress, newfracprogress);
fracprogress=newfracprogress;
this.progress=fprogress;
var lasteta=this.etime;
var rate=(Long.$dval((Long.$sub(System.currentTimeMillis$(),time)))) / Long.$dval(this.progress);
this.etime=rate * (Long.$sub(this.total,this.progress)) / 60000;
this.firePropertyChange$S$D$D("eta_in_minutes", lasteta, this.etime);
}}
alignmentScores[count - 1][count - 1]=NaN;
this.firePropertyChange$S$I$I("total", -1, -2);
this.scores=scores;
this.alignmentScores=alignmentScores;
if (count > 2 && !this.quiet ) {
this.printScoreMatrix$jalview_datamodel_SequenceIA$FAA$D(this.seqs, scores, totscore);
}this.alignmentOutput=sb.toString();
});

Clazz.newMeth(C$, 'hasEta$',  function () {
return this.etime > 0 ;
});

Clazz.newMeth(C$, 'getEta$',  function () {
return this.etime;
});

Clazz.newMeth(C$, 'cancel$',  function () {
this.cancelled=true;
});

Clazz.newMeth(C$, 'getScores$',  function () {
return this.scores;
});

Clazz.newMeth(C$, 'getAlignmentScores$',  function () {
return this.alignmentScores;
});

Clazz.newMeth(C$, 'getAlignmentOutput$',  function () {
return this.alignmentOutput;
});

Clazz.newMeth(C$, 'printScoreMatrix$jalview_datamodel_SequenceIA$FAA$D',  function (seqs, scores, totscore) {
System.out.println$S("Pairwise alignment scaled similarity score matrix " + this.getPairwiseSimscoresAsString$() + "\n" );
for (var i=0; i < seqs.length; i++) {
$I$(4,"outPrintln$O",[String.format$S$OA("%3d %s", Clazz.array(java.lang.Object, -1, [Integer.valueOf$I(i + 1), seqs[i].getDisplayId$Z(true)]))]);
}
System.out.print$S("\n ");
for (var i=0; i < seqs.length; i++) {
System.out.print$S(String.format$S$OA("%7d", Clazz.array(java.lang.Object, -1, [Integer.valueOf$I(i + 1)])));
}
$I$(4).outPrintln$();
for (var i=0; i < seqs.length; i++) {
System.out.print$S(String.format$S$OA("%3d", Clazz.array(java.lang.Object, -1, [Integer.valueOf$I(i + 1)])));
for (var j=0; j < i; j++) {
System.out.print$S(String.format$S$OA("%7.3f", Clazz.array(java.lang.Object, -1, [Double.valueOf$D(scores[i][j] / totscore)])));
}
$I$(4).outPrintln$();
}
$I$(4).outPrintln$O("\n");
});

Clazz.newMeth(C$, 'getPairwiseSimscoresAsString$',  function () {
return (this.scoreMatrix != null  ? " (" + this.scoreMatrix.getName$() + ", open=" + this.GAP_OPEN_COST + ", extend=" + this.GAP_EXTEND_COST + (this.endGaps ? ", with endGaps" : ", no endGaps") + ")"  : "");
});

Clazz.newMeth(C$, 'viewInEditorButton_actionPerformed$java_awt_event_ActionEvent',  function (e) {
var seq=Clazz.array($I$(5), [this.sequences.size$()]);
for (var i=0; i < this.sequences.size$(); i++) {
seq[i]=this.sequences.elementAt$I(i);
}
var af=Clazz.new_([Clazz.new_($I$(7,1).c$$jalview_datamodel_SequenceIA,[seq]), 700, 500],$I$(6,1).c$$jalview_datamodel_AlignmentI$I$I);
$I$(8,"addInternalFrame$javax_swing_JInternalFrame$S$I$I",[af, $I$(9).getString$S("label.pairwise_aligned_sequences") + " " + this.getPairwiseSimscoresAsString$() , 700, 500]);
});

Clazz.newMeth(C$, 'getTotal$',  function () {
return this.total;
});

Clazz.newMeth(C$, 'getProgress$',  function () {
return this.progress;
});

Clazz.newMeth(C$, 'getInputSequences$',  function () {
return this.seqs;
});

Clazz.newMeth(C$, 'setQuiet$Z',  function (quiet) {
this.quiet=quiet;
});

Clazz.newMeth(C$, 'isQuiet$',  function () {
return this.quiet;
});

Clazz.newMeth(C$, 'setDiscardAlignments$Z',  function (discard) {
this.discardAlignments=discard;
});

Clazz.newMeth(C$, 'isDiscardAlignments$',  function () {
return this.discardAlignments;
});

Clazz.newMeth(C$, 'isCancelled$',  function () {
return this.cancelled;
});

Clazz.newMeth(C$, 'updateProgress$S$S',  function (type, message) {
this.firePropertyChange$S$O$O(type, "", $I$(9).getStringOrReturn$S$S("progress", message));
});

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:09 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
