(function(){var P$=Clazz.newPackage("jalview.math"),I$=[[0,'jalview.util.Format']],I$0=I$[0],$I$=function(i,n){return((i=(I$[i]||(I$[i]=Clazz.load(I$0[i])))),!n&&i.$load$&&Clazz.load(i,2),i)};
/*c*/var C$=Clazz.newClass(P$, "MiscMath");

C$.$clinit$=2;

Clazz.newMeth(C$, '$init$', function () {
},1);

Clazz.newMeth(C$, 'print$DA$S',  function (m, format) {
System.out.print$S("[ ");
for (var a, $a = 0, $$a = m; $a<$$a.length&&((a=($$a[$a])),1);$a++) {
$I$(1).print$java_io_PrintStream$S$D(System.out, format + " ", a);
}
System.out.println$S("]");
}, 1);

Clazz.newMeth(C$, 'mean$DA',  function (m) {
var sum=0;
var nanCount=0;
for (var i=0; i < m.length; i++) {
if (!Double.isNaN$D(m[i])) {
sum+=m[i];
} else {
++nanCount;
}}
return sum / (m.length - nanCount);
}, 1);

Clazz.newMeth(C$, 'sum$DA',  function (m) {
var sum=0;
for (var i=0; i < m.length; i++) {
if (!Double.isNaN$D(m[i])) {
sum+=m[i];
}}
return sum;
}, 1);

Clazz.newMeth(C$, 'sqrt$DA',  function (m) {
var sqrts=Clazz.array(Double.TYPE, [m.length]);
for (var i=0; i < m.length; i++) {
sqrts[i]=Math.sqrt(m[i]);
}
return sqrts;
}, 1);

Clazz.newMeth(C$, 'elementwiseMultiply$BA$DA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('jalview.math.SameLengthException').c$$I$I,[a.length, b.length]);
}var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=a[i] * b[i];
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseMultiply$DA$DA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('jalview.math.SameLengthException').c$$I$I,[a.length, b.length]);
}var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=a[i] * b[i];
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseMultiply$BA$BA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('jalview.math.SameLengthException').c$$I$I,[a.length, b.length]);
}var result=Clazz.array(Byte.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=((a[i] * b[i])|0);
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseMultiply$DA$D',  function (a, b) {
var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=a[i] * b;
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseDivide$DA$DA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('jalview.math.SameLengthException').c$$I$I,[a.length, b.length]);
}var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=a[i] / b[i];
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseAdd$DA$DA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('jalview.math.SameLengthException').c$$I$I,[a.length, b.length]);
}var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]+=a[i] + b[i];
}
return result;
}, 1);

Clazz.newMeth(C$, 'elementwiseAdd$DA$D',  function (a, b) {
var result=Clazz.array(Double.TYPE, [a.length]);
for (var i=0; i < a.length; i++) {
result[i]=a[i] + b;
}
return result;
}, 1);

Clazz.newMeth(C$, 'allClose$DA$DA$D$D$Z',  function (a, b, rtol, atol, equalNAN) {
var areEqual=true;
for (var i=0; i < a.length; i++) {
if (equalNAN && (Double.isNaN$D(a[i]) && Double.isNaN$D(b[i]) ) ) {
continue;
}if (Math.abs(a[i] - b[i]) > (atol + rtol * Math.abs(b[i])) ) {
areEqual=false;
break;
}}
return areEqual;
}, 1);

Clazz.newMeth(C$, 'findMax$IA',  function (a) {
var max=0;
var maxIndex=0;
for (var i=0; i < a.length; i++) {
if (a[i] > max) {
max=a[i];
maxIndex=i;
}}
return Clazz.array(Integer.TYPE, -1, [maxIndex, max]);
}, 1);

Clazz.newMeth(C$, 'dot$DA$DA',  function (a, b) {
if (a.length != b.length) {
throw Clazz.new_(Clazz.load('IllegalArgumentException').c$$S,[String.format$S$OA("Vectors do not have the same length (%d, %d)!", Clazz.array(java.lang.Object, -1, [Integer.valueOf$I(a.length), Integer.valueOf$I(b.length)]))]);
}var aibi=0;
for (var i=0; i < a.length; i++) {
aibi+=a[i] * b[i];
}
return aibi;
}, 1);

Clazz.newMeth(C$, 'norm$DA',  function (v) {
var result=0;
for (var i, $i = 0, $$i = v; $i<$$i.length&&((i=($$i[$i])),1);$i++) {
result+=Math.pow(i, 2);
}
return Math.sqrt(result);
}, 1);

Clazz.newMeth(C$, 'countNaN$DA',  function (v) {
var cnt=0;
for (var i, $i = 0, $$i = v; $i<$$i.length&&((i=($$i[$i])),1);$i++) {
if (Double.isNaN$D(i)) {
++cnt;
}}
return cnt;
}, 1);

Clazz.newMeth(C$, 'permutations$I$I',  function (n, r) {
if (n < r) return C$.permutations$I$I(r, n);
var result=1;
for (var i=0; i < r; i++) {
(result=Long.$mul(result,((n - i))));
}
return result;
}, 1);

Clazz.newMeth(C$, 'combinations$I$I',  function (n, r) {
var result=1;
for (var i=0; i < r; i++) {
result*=(n - 1);
}
return ((result/C$.factorial$I(r)|0));
}, 1);

Clazz.newMeth(C$, 'factorial$I',  function (n) {
var result=1;
for (var i=0; i < n; i++) {
result*=(n - i);
}
return result;
}, 1);

Clazz.newMeth(C$);
})();
;Clazz.setTVer('3.3.1-v1');//Created 2024-11-13 16:11:14 Java2ScriptVisitor version 3.3.1-v1 net.sf.j2s.core.jar version 3.3.1-v1
